// -*- c++ -*-
/* This is a generated file, do not edit.  Generated from template.macros.m4 */

#ifndef SIGC_SIGNAL_WRAPPER_H
#define SIGC_SIGNAL_WRAPPER_H

#include <sigc++/slot.h>
#include <sigc++/class_slot.h>
#include <sigc++/retype.h>
#include <sigc++/signal.h>

#include <yehia/script/types.h>
#include <yehia/script/slot-convert.h>

namespace Yehia
{

namespace Script
{


/****************************************************************/

template <class R>
inline SigC::Slot0<R> signal_connect_convert(SigC::Signal0<R> *, const Slot& s)
{
  return convert<R>(s);
}
template <class R>
Any signal_emit_wrap(SigC::Signal0<R> *s, const std::list<Any>& args)
{
  SigC::Slot0<R> slot = SigC::retype<R>(SigC::slot_class(*s, &SigC::Signal0<R>::emit));
  return MarshalWrapper0<R>::unmarshal(slot, args);
}

template <class R,class P1>
inline SigC::Slot1<R,P1> signal_connect_convert(SigC::Signal1<R,P1> *, const Slot& s)
{
  return convert<R,P1>(s);
}
template <class R,class P1>
Any signal_emit_wrap(SigC::Signal1<R,P1> *s, const std::list<Any>& args)
{
  SigC::Slot1<R,P1> slot = SigC::retype<R,P1>(SigC::slot_class(*s, &SigC::Signal1<R,P1>::emit));
  return MarshalWrapper1<R,P1>::unmarshal(slot, args);
}

template <class R,class P1,class P2>
inline SigC::Slot2<R,P1,P2> signal_connect_convert(SigC::Signal2<R,P1,P2> *, const Slot& s)
{
  return convert<R,P1,P2>(s);
}
template <class R,class P1,class P2>
Any signal_emit_wrap(SigC::Signal2<R,P1,P2> *s, const std::list<Any>& args)
{
  SigC::Slot2<R,P1,P2> slot = SigC::retype<R,P1,P2>(SigC::slot_class(*s, &SigC::Signal2<R,P1,P2>::emit));
  return MarshalWrapper2<R,P1,P2>::unmarshal(slot, args);
}

template <class R,class P1,class P2,class P3>
inline SigC::Slot3<R,P1,P2,P3> signal_connect_convert(SigC::Signal3<R,P1,P2,P3> *, const Slot& s)
{
  return convert<R,P1,P2,P3>(s);
}
template <class R,class P1,class P2,class P3>
Any signal_emit_wrap(SigC::Signal3<R,P1,P2,P3> *s, const std::list<Any>& args)
{
  SigC::Slot3<R,P1,P2,P3> slot = SigC::retype<R,P1,P2,P3>(SigC::slot_class(*s, &SigC::Signal3<R,P1,P2,P3>::emit));
  return MarshalWrapper3<R,P1,P2,P3>::unmarshal(slot, args);
}

template <class R,class P1,class P2,class P3,class P4>
inline SigC::Slot4<R,P1,P2,P3,P4> signal_connect_convert(SigC::Signal4<R,P1,P2,P3,P4> *, const Slot& s)
{
  return convert<R,P1,P2,P3,P4>(s);
}
template <class R,class P1,class P2,class P3,class P4>
Any signal_emit_wrap(SigC::Signal4<R,P1,P2,P3,P4> *s, const std::list<Any>& args)
{
  SigC::Slot4<R,P1,P2,P3,P4> slot = SigC::retype<R,P1,P2,P3,P4>(SigC::slot_class(*s, &SigC::Signal4<R,P1,P2,P3,P4>::emit));
  return MarshalWrapper4<R,P1,P2,P3,P4>::unmarshal(slot, args);
}

template <class R,class P1,class P2,class P3,class P4,class P5>
inline SigC::Slot5<R,P1,P2,P3,P4,P5> signal_connect_convert(SigC::Signal5<R,P1,P2,P3,P4,P5> *, const Slot& s)
{
  return convert<R,P1,P2,P3,P4,P5>(s);
}
template <class R,class P1,class P2,class P3,class P4,class P5>
Any signal_emit_wrap(SigC::Signal5<R,P1,P2,P3,P4,P5> *s, const std::list<Any>& args)
{
  SigC::Slot5<R,P1,P2,P3,P4,P5> slot = SigC::retype<R,P1,P2,P3,P4,P5>(SigC::slot_class(*s, &SigC::Signal5<R,P1,P2,P3,P4,P5>::emit));
  return MarshalWrapper5<R,P1,P2,P3,P4,P5>::unmarshal(slot, args);
}


/****************************************************************/

class Signal : public SigC::Object
{
  public:
    virtual void connect(const Any::SlotValue& s) = 0;
    virtual Any emit(const std::list<Any>& args) = 0;
};

class ScriptSignal : public Signal
{
  public:
    virtual void connect(const Any::SlotValue& s) {
      signal_.connect(s.slot);
    }
    virtual Any emit(const std::list<Any>& args) { 
      return signal_.emit(args); 
    }
  private:
    SigC::Signal1<Any, const std::list<Any>&> signal_;
};
  
template <class T>
class SignalImpl : public Signal
{
  public:
    SignalImpl(T& signal) : signal_(&signal) {}
    virtual void connect(const Any::SlotValue& sv) {
      signal_->connect(signal_connect_convert(signal_, sv.slot));
    }
    virtual Any emit(const std::list<Any>& args) {
      return signal_emit_wrap(signal_, args);
    }
  private:
    T *signal_;
};

template <class T, class S>
class SignalFactory
{
  public:
    static SigC::Slot1<Signal *, T&> create(S T::* signal) {
      return SigC::bind(SigC::slot(&SignalFactory<T, S>::creator), signal);
    }
  private:
    static Signal *creator(T& obj, S T::* signal) {
      return SigC::manage(new SignalImpl<S>(obj.*signal));
    }
};

template <class T>
class SignalWrapper
{
  public:
    template <class SignalType>
    SignalWrapper(SignalType T::* signal) {
      slot_ = SignalFactory<T, SignalType>::create(signal);
    }
    const SigC::Slot1<Signal *, T&>& getter() const { return slot_; }
  private:
    SigC::Slot1<Signal *, T&> slot_;
};



} // namespace Script

} // namespace Yehia

#endif
